{-# LANGUAGE BangPatterns, NoImplicitPrelude #-}

module UnitFractionsDecomposition2 where

import GHC.Base
import GHC.Num ((+),(-),(*),abs)
import GHC.List (null)
import Data.List (minimumBy)
import GHC.Real (infinity,fromRational,round,fromIntegral,(/),truncate)

setOfSolutions :: Double -> Double -> [(Double, Double)]
setOfSolutions k n 
 | 0 < k && k < 1 && n > minProportion k = [(x, x/(k*x - 1)) | x <- [fromIntegral (truncate (1.0 / k)) + 1.0..fromIntegral (truncate (2.0 / k))]]
 | otherwise = []
{-# INLINE setOfSolutions #-}

suitable2 :: Double -> Double -> (Double,Double)
suitable2 k n
 | null xs = (undefined, undefined)
 | otherwise = minimumBy (\(_, y1) (_, y2) -> compare (abs (y1 - fromIntegral (round y1))) (abs (y2 - fromIntegral (round y2)))) xs
      where !xs = setOfSolutions k n
{-# INLINE suitable2 #-}

suitable21 :: Double -> Double -> ([Double],Double)
suitable21 k n 
 | null xs = ([],undefined)
 | otherwise = let (!a,!b) = minimumBy (\(_, y1) (_, y2) -> compare (abs (y1 - fromIntegral (round y1))) (abs (y2 - fromIntegral (round y2)))) xs
    in ([a,b],k - (1.0/a + 1.0/fromIntegral (round b)))
      where !xs = setOfSolutions k n
{-# INLINE suitable21 #-}

minProportion :: Double -> Double
minProportion k 
 | 0 < k && k < 1 = 1.0 / (fromIntegral (truncate (2.0/k)) * k - 1.0)
 | otherwise = fromRational infinity
{-# INLINE minProportion #-}

